//-----------------------------------------------------------------
// SX15-Evo Firmware di test con SXLCD
// Data : 25-01-06
// Versione : 1.0
// Area SX
// http://www.areasx.com
// Note     : per utilizzare il firmware collegare il connettore JP4
// della scheda SX15E al connettore Master In della scheda SXLCD
// ed impostare su ON i ponticelli 5 e 7 del DIP S3
//
//-----------------------------------------------------------------
//-----------------------------------------------------------------

//-----------------------------------------------------------------
// Configurazione Firmware
//-----------------------------------------------------------------


//-----------------------------------------------------------------
// Define Hardware
//-----------------------------------------------------------------
#define LEDLD1_ON       BitWrPortI(PFDR,&PFDRShadow,1,1)
#define LEDLD1_OFF      BitWrPortI(PFDR,&PFDRShadow,0,1)
#define LEDLD2_ON       BitWrPortI(PFDR,&PFDRShadow,1,0)
#define LEDLD2_OFF      BitWrPortI(PFDR,&PFDRShadow,0,0)
#define LEDLD3_ON       BitWrPortI(PFDR,&PFDRShadow,1,4)
#define LEDLD3_OFF      BitWrPortI(PFDR,&PFDRShadow,0,4)

#define KEY_PRESSED   BitRdPortI(PEDR,1)


#define BINBUFSIZE    511
#define BOUTBUFSIZE   511


//-----------------------------------------------------------------
// Globali
//-----------------------------------------------------------------
char rxBuff[512];
char txBuff[512];
char tmpbuf[500];
int nchar;
int i;

//-----------------------------------------------------------------
// Prototipi
//-----------------------------------------------------------------
void BoardInit(void);
void msDelay(unsigned int);


//--------------------------------------------------------
// Ritardo bloccante
// Riceve      : ams - numero di millisecondi da ritardare
// Restituisce : -
// Note        :
//--------------------------------------------------------
nodebug
void msDelay(unsigned int ams)
{
  auto unsigned long t0;
  for(t0=MS_TIMER; MS_TIMER<ams+t0;);
}

//--------------------------------------------------------
// Inizializza i port del modulo RCM
// Riceve      : -
// Restituisce : -
// Note        :
//--------------------------------------------------------
void BoardInit() {

  // Port A
  // Default ingresso

  // Port B
  // PB0 - ICL (output)
  BitWrPortI(PBDDR,&PBDDRShadow,1,0);
  // PB2 - IDA (input)
  // PB3 - IPL (output)
  BitWrPortI(PBDDR,&PBDDRShadow,1,3);
  // PB4 - OCL (output)
  BitWrPortI(PBDDR,&PBDDRShadow,1,4);
  // PB5 - STR (output)
  BitWrPortI(PBDDR,&PBDDRShadow,1,5);
  // PB7 - ODA (output)
  BitWrPortI(PBDDR,&PBDDRShadow,1,7);

  // Port C
  // PC0-PC1 - Seriale D
  BitWrPortI(PCFR, &PCFRShadow, 1,0);

  // PC2-PC3 - Seriale C
  // Modem GSM
  BitWrPortI(PCFR, &PCFRShadow, 1,2);

  // Port D
  // PD4-PD5 - Seriale B
  BitWrPortI(PDFR,&PDFRShadow,1,4);
  BitWrPortI(PDDDR,&PDDDRShadow,1,4);
  
  // Port E
  WrPortI(PEFR, &PEFRShadow, 0x00);
  // PE0 - DCD Modem GSM (ingresso)
  // PE1 - Pulsante esterno (ingresso)
  // PE4 - GSM Power Control (ingresso)
  // PE5 - RS485 Data Direction / RS232 DTR (output)
  BitWrPortI(PEDDR, &PEDDRShadow, 1,5);
  // PE7 - GSM On/Off (output)
  BitWrPortI(PEDDR, &PEDDRShadow, 1,7);

  // Port F
  WrPortI(PFFR, &PFFRShadow, 0x00);
  WrPortI(PFDCR, &PFDCRShadow, 0x00);
  // PF0 - Led LD3 (output)
  BitWrPortI(PFDDR, &PFDDRShadow, 1,0);
  // PF1 - Led LD1 (output)
  BitWrPortI(PFDDR, &PFDDRShadow, 1,1);
  // PF4 - Led LD2 (output)
  BitWrPortI(PFDDR, &PFDDRShadow, 1,4);
  // PF5 - Modem Reset (output)
  BitWrPortI(PFDDR, &PFDDRShadow, 1,5);
  // PF6 - SH71 External I2c (bid)
  // PF7 - SH71 External I2c (bid)

  // Port G
  WrPortI(PGFR, &PGFRShadow, 0x00);
  // PG6-PG7 - Seriale E (RF Transmitter, Caller Id, GPS Receiver)
  BitWrPortI(PGFR, &PGFRShadow, 1,6);
  BitWrPortI(PGDDR, &PGDDRShadow, 0,7);
  BitWrPortI(PGDDR, &PGDDRShadow, 1,6);

}



// -----------------------------------------------------------------------
// -----------------------------------------------------------------------
//                               MAIN
// -----------------------------------------------------------------------
// -----------------------------------------------------------------------
main () {

  char ch;
  int i,j;
  int ADRes;
  char cmd;
  char addr;
  char data1;
  char data2;
  char s[100];
  char msg[100];
  char len;

  // Inizializzazione Scheda
  BoardInit();

  // Inizializzo la seriale B
  serBopen(19200);

  printf ("SX15-Evo con SXLCD: System Ready\n");


  while (1) {

		  printf("\nInserisci l'indirizzo del display (invio per broadcast): ");
		  gets(s);

		  if (strlen(s)) {
		    addr = atoi(s);
		  } else {
		    addr=0xFF;
		  }

      printf("\n0 - Undocumented Ver");
      printf("\n1 - Cancella display ");
      printf("\n2 - Scrivi messaggio");
      printf("\n3 - Scrivi messaggi in posizione");
      printf("\n4 - Imposta Backlight");
      printf("\n5 - Imposta indirizzo");
      printf("\n6 - Imposta cursore");
      printf("\n7 - Configura display");
      printf("\n8 - Imposta il Wrap Mode");
      
      printf("\n\n99 - BL Ramp");
		  printf("\nInserisci il comando da inviare: ");
		  gets(s);
		  cmd = atoi(s);

		  switch (cmd) {

		  case 0x00:
		    printf ("->COMANDO: FW Version\n");
		    data1=0;
		    data2=0;
		    sprintf(msg,"");
		    break;

		  case 0x01:
		    printf ("->COMANDO: Cancella display\n");
		    data1=0;
		    data2=0;
		    sprintf(msg,"");
		    break;

		  case 0x02:
		    printf ("->COMANDO: Scrivi messaggio\n");
		    printf("\nInserisci messaggio da inviare: ");
		    gets(s);
		    data1=0;
		    data2=0;
		    sprintf(msg,"%s",s);
		    break;

		  case 0x03:
		    printf ("->COMANDO: Scrivi messaggio in posizione\n");

		    printf("\nPosizione X (0-19): ");
		    gets(s);
		    data1 = atoi(s);

		    printf("\nPosizione Y (0-3): ");
		    gets(s);
		    data2 = atoi(s);

		    printf("\nInserisci messaggio da inviare: ");
		    gets(s);
		    sprintf(msg,"%s",s);

		    break;

		  case 0x04:
		    printf ("->COMANDO: Imposta Livello backlight\n");
		    printf("\n0 - Spenta, 1 - 255 parzializzata: ");
		    gets(s);
		    data1 = atoi(s);
		    data2=0;
		    sprintf(msg,"");

		    break;

		  case 0x05:
		    printf ("->COMANDO: Imposta indirizzo display\n");
		    printf("\nNuovo indirizzo (1-254): ");
		    gets(s);
		    data1 = atoi(s);
		    data2=0;
		    sprintf(msg,"");
		    break;

		  case 0x06:
		    printf ("->COMANDO: Imposta cursore\n");
		    printf("\n0 - No Cursor ,1 - Cursore fisso, 2- cursore lampeggiante: ");
		    gets(s);
		    data1 = atoi(s);
		    data2=0;
		    sprintf(msg,"");
		    break;

		  case 0x07:
		    printf ("->COMANDO: Configurazione Display\n");

		    printf("\nIndirizzo Riga 1: ");
		    gets(s);
		    data1 = atoi(s);

		    printf("\nIndirizzo Riga 2: ");
		    gets(s);
		    data2 = atoi(s);
		    
		    printf("\nIndirizzo Riga 3 (255 per nessuno): ");
		    gets(s);
		    msg[0] = atoi(s);

		    printf("\nIndirizzo Riga 4 (255 per nessuno): ");
		    gets(s);
		    msg[1] = atoi(s);

		    printf("\nNumero di righe e colonne (YYYXXXXX) : ");
		    gets(s);
		    msg[2] = atoi(s);		    
		    
		    msg[3]=0;
		    break;

		  case 0x08:
		    printf ("->COMANDO: Imposta Wrap Mode (a capo automatico)\n");
		    printf("\n0 - No Wrap Mode ,1 - Wrap Abilitato: ");
		    gets(s);
		    data1 = atoi(s);
		    data2=0;
		    sprintf(msg,"");
		    break;

      case 99:
		    printf ("->COMANDO: Rampa backlight\n");
		    printf("\nStep di rampa: ");
		    gets(s);
		    data1 = atoi(s);
      
        for (j=0;j<255;j+=data1) {
          
          txBuff[0]='>';
          txBuff[1]=0xFF; // ADDRESS
          txBuff[2]=0x04;  //Write AT CMD
          txBuff[3]=j;     //Write AT D1
          txBuff[4]=0;     //Write AT D2
          txBuff[5]=0;

          printf ("Set BL [%d]\n",j);
          for (i=0;i<len;i++) {            
            serBputc(txBuff[i]);
          }          
          msDelay(50);
        }

        for (j=255;j>0;j-=data1) {
          
          txBuff[0]='>';
          txBuff[1]=0xFF; // ADDRESS
          txBuff[2]=0x04;  //Write AT CMD
          txBuff[3]=j;     //Write AT D1
          txBuff[4]=0;     //Write AT D2
          txBuff[5]=0;

          printf ("Set BL [%d]\n",j);
          for (i=0;i<len;i++) {            
            serBputc(txBuff[i]);
          }          
          msDelay(50);          
        }

		  }
      
      if (cmd!=99) {
        txBuff[0]='>';
        txBuff[1]=addr;      // ADDRESS
        txBuff[2]=cmd;       //Write AT CMD
        txBuff[3]=data1;     //Write AT D1
        txBuff[4]=data2;     //Write AT D2
        for (i=0;i<strlen(msg);i++) {
          txBuff[5+i]=msg[i];
        }
        txBuff[5+i]=0x00;
        len=5+i+1;
  
        printf ("Invio comando\n");
  
        for (i=0;i<len;i++) {
          printf ("[%02x]",txBuff[i]);
          serBputc(txBuff[i]);
        }
  
        printf ("\n\n");
  
        msDelay(100);

      }

  }

}